/*
    Copyright (C) 2003 Paul Davis 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    $Id: audioplaylist.h,v 1.1 2003/10/29 04:27:23 pbd Exp $
*/

#ifndef __ardour_audio_playlist_h__
#define __ardour_audio_playlist_h__

#include <ardour/ardour.h>
#include <ardour/playlist.h>

namespace ARDOUR  {

class Session;
class Region;

class AudioPlaylist : public ARDOUR::Playlist
{
   public:
	AudioPlaylist (Session&, const XMLNode&, bool hidden = false);
	AudioPlaylist (Session&, string name, bool hidden = false);
	AudioPlaylist (const AudioPlaylist&, string name, bool hidden = false);
	AudioPlaylist (const AudioPlaylist&, jack_nframes_t start, jack_nframes_t cnt, string name, bool hidden = false);

        jack_nframes_t read (Sample *dst, Sample *mixdown, float *gain_buffer, jack_nframes_t start, jack_nframes_t cnt, unsigned int chan_n=0);

    protected:
	virtual void add_region_internal (Region *, jack_nframes_t position, bool delay_sort = false);
        virtual void check_overlaps (Region *region);
        virtual void remove_overlaps (Region *region);

    protected:
       ~AudioPlaylist (); /* public should use unref() */
};

} /* namespace ARDOUR */

#endif	/* __ardour_audio_playlist_h__ */


