/*
    Copyright (C) 2003 Paul Davis 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    $Id: playlist_templates.h,v 1.1 2003/10/29 04:27:23 pbd Exp $
*/

#ifndef __ardour_playlist_templates_h__
#define __ardour_playlist_templates_h__

namespace ARDOUR {

template<class T> void Playlist::foreach_overlap (T *t, void (T::*func)(Overlap *)) {
	RegionLock rlock (this, false);
	for (Overlaps::iterator i = _overlaps.begin(); i != _overlaps.end(); i++) {	
		(t->*func) (*i);
	}
	}

template<class T> void Playlist::foreach_region (T *t, void (T::*func)(Region *, void *), void *arg) {
	RegionLock rlock (this, false);
	for (RegionList::iterator i = regions.begin(); i != regions.end(); i++) {	
		(t->*func) ((*i), arg);
	}
	}

template<class T> void Playlist::foreach_region (T *t, void (T::*func)(Region *)) {
	RegionLock rlock (this, false);
	for (RegionList::const_iterator i = regions.begin(); i != regions.end(); i++) {
		(t->*func) (*i);
	}
}

}

#endif /* __ardour_playlist_templates_h__ */
